#include <stdbool.h>
#include <stdlib.h>

struct Element
{
  int x;
  int y;
  int value;
};

typedef struct Element Element;

struct SparseMatrix
{
  unsigned int numElements;
  Element* matrix;
};

typedef struct SparseMatrix SparseMatrix;

SparseMatrix buildMatrix(int numElements)
{
  SparseMatrix s;
  s.numElements = numElements;
  s.matrix = (Element*)malloc(numElements*sizeof(Element));
  return s;
}

void releaseMatrix(SparseMatrix m)
{
  free(m.matrix);
}
  
int get(SparseMatrix m, int x, int y)
{
  for(int i = 0; i < m.numElements; i++)
  {
    if(m.matrix[i].x == x && m.matrix[i].y == y)
    {
      return m.matrix[i].value;
    }
  }
  return 0;
}

bool set(SparseMatrix m, int x, int y, int value)
{
  // Gibts den schon?
  for(int i = 0; i < m.numElements; i++)
  {
    if(m.matrix[i].x == x && m.matrix[i].y == y)
    {
      // Wenn ja: berschreiben
      m.matrix[i].value = value;
      return true;
    }
  }  
  
  // Wenn nein: Anhngen
  
  // Finde den ersten, dessen value auf 0 steht
  for(int i = 0; i < m.numElements; i++)
  {
    if(m.matrix[i].value == 0)
    {
      // Wenn ja: berschreiben
      m.matrix[i].x = x;
      m.matrix[i].y = y;
      m.matrix[i].value = value;
      return true;
    }
  }
  
  return false;
}

int main( void )
{
  SparseMatrix s = buildMatrix(100);
  int a = get(s, 13, 42);
  bool b = set(s, 13, 42, 100);
  a = get(s, 13, 42);
  releaseMatrix(s);
  return 0;
}
